
#ifndef ALP_PDK_GRAS_H_
#define ALP_PDK_GRAS_H_ 1
#include <stdint.h>

#define     dmDBNameLength                          32

#define ALP_CLASS_GRAS               0x30000000
#define ALP_STATUS_GRAS_GARNET_ERROR                (ALP_CLASS_GRAS | 0x00060000)
#define ALP_GRAS_SESSION_TYPE_DB            3
#define ALP_GRAS_CLOSE_DELAY_NORMAL         10000

 struct _Alp68KDBInfo { 
 
         uint8_t        name[dmDBNameLength];   //  0 - name of database
        uint16_t       attributes;                             // 32 - database attributes
        uint16_t       version;                                // 34 - version of database

        uint32_t       creationDate;                   // 36 - creation date of database
        uint32_t       modificationDate;               // 40 - latest modification date
        uint32_t       lastBackupDate;                 // 44 - latest backup date
        uint32_t       modificationNumber;             // 48 - modification number of database

        uint8_t        storage;                                // 52 - 0 : internal, or [1..nCards] for card slots
        uint8_t        padding[7];                             // 53

        uint32_t       type;                                   // 60 - database type
        uint32_t       creator;                                // 64 - database creator

        uint32_t       reserved[3];                    // 68

 
 };                                                                      // 80
typedef struct _Alp68KDBInfo Alp68KDBInfo;

struct _Alp68KAppKeysSettings {
        unsigned int            hardButton1;
        unsigned int            hardButton2;
        unsigned int            hardButton3;
        unsigned int            hardButton4;

        unsigned int            rockerUp;
        unsigned int            rockerDown;
        unsigned int            rockerLeft;
        unsigned int            rockerRight;
        unsigned int            rockerCenter;

        unsigned int            pageUp;
        unsigned int            pageDown;
};
typedef struct _Alp68KAppKeysSettings Alp68KAppKeysSettings;


// All fields are so that 0 is the default value, so you can just memset it
typedef struct _Alp68KAppConfig
{
        int                     screenSize;
        // On ALP, the following is ignored and screen mode can't be NORMAL
        // It must be FULL or SQUARE
        int                     qvgaScaling;
        int                     screenMode;

        int                     vmouse;
        int                     dynHeapSize;
        int                     storageSize;
        int             sdAutorunDisabled;
        // Use 0 for default
        uint32_t        deviceid;
        // Use 0 for default
        uint32_t        companyid;
        // Use 0 for default, or 'enUS', ...
        uint32_t        locale;
        int                     soundMuted;
        char*           serialNum;
        // Keys. Use 0 to not map
        Alp68KAppKeysSettings   *keysMap;
        // More individual Keys mapping. Use 0 to not use.
        int                     keysMapIndCount;
       
} Alp68KAppConfig;



#define     dmHdrAttrHidden                         0x0100 
#define     dmHdrAttrResDB                          0x0001
#endif

