/******************************************************************************
 * Copyright (c) 2006 PalmSource, Inc (an ACCESS company). All rights reserved.
 *****************************************************************************/
 /*!
 * @file <alp/pdk/gras_notif.h>
 *
 * @brief GHost Remote Access Service exported notifications
 *
 *****************************************************************************/

#ifndef ALP_PDK_GRAS_NOTIF_H_
#define ALP_PDK_GRAS_NOTIF_H_	1

#include <hiker/types.h>
#include <alp/pdk/gras.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @addtogroup ALP_GHOST_REMOTE Remote Access Service
 * @ingroup ALP_GHOST
 * @{
 */

/************************************************************
 * Errors
 *************************************************************/
// ALP_BUILD is always defined when building in ALP.
#ifndef ALP_BUILD
	#error This file is for ALP only
#endif

/************************************************************
 *  Notifications
 *************************************************************/

#define GRAS_NOTIFICATIONS "alp_gras"

typedef struct _AlpGRASDBChangeEventDetails AlpGRASDBChangeEventDetails;
struct _AlpGRASDBChangeEventDetails {
    unsigned int db_type;
    unsigned int db_creator;
    char db_name[dmDBNameLength];
    int storage;
    //! True if db is being created, false if it is being deleted
    int creation;
};

//! GRAS notifications (sent on behalf of GRAS by PAL, called by GHost)
#define ALP_NOTIFY_EVENT_GRAS_DB_CHANGE		"/alp/gras/dbchange"
#define ALP_NOTIFY_EVENT_GRAS_PATH_CHANGE	"/alp/gras/pathchange"

#ifndef ALP_GRAS_DBENVELOP_NAME
	// These must stay in sync with <libraries/pal/pal_misc.h>
	#define ALP_GRAS_DBENVELOP_NAME			1
	#define ALP_GRAS_DBENVELOP_TYPE			2
	#define ALP_GRAS_DBENVELOP_CREATOR		4
	#define ALP_GRAS_DBENVELOP_ATTRIBUTES	8
	#define ALP_GRAS_DBENVELOP_VERSION		16
	
	typedef struct _AlpGRASDBEnvelopChangeEventDetails AlpGRASDBEnvelopChangeEventDetails;
	struct _AlpGRASDBEnvelopChangeEventDetails {
		unsigned int	changes;
	    unsigned int 	type, old_type;
	    unsigned int 	creator, old_creator;
	    unsigned short	attributes, old_attributes;
	    unsigned short	version;
	    char 			name[dmDBNameLength], old_name[dmDBNameLength];
	};
#endif

//! GRAS notifications (sent on behalf of GRAS by PAL, called by GHost)
#define ALP_NOTIFY_EVENT_GRAS_DBENVELOP_CHANGE		"/alp/gras/dbenvelop"
#define ALP_NOTIFY_EVENT_GRAS_STORAGE_REMOVED		"/alp/gras/storageremoved"

/* @} */

#ifdef __cplusplus
}
#endif

#endif /* ALP_PDK_GRAS_NOTIF_H_ */
