/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <hiker/config.h>
 *
 * @brief Build configuration
 *
 ******************************************************************************/

#ifndef ALP_CONFIG_H_
#define ALP_CONFIG_H_

// ---------------------------------------------------------------------------
#include <hiker/config_defines.h>

// ---------------------------------------------------------------------------
// Must be defined by the build system. 
// Since it's really important, we cannot simply use a default value for it.
#if !defined(ALP_BUILD)
#	error ALP_BUILD MUST be defined by the build system
#endif

// ##############################################
// THIS IS VERY TEMPORARY UNTIL WE HAVE COMBOS
// ##############################################
#define ALP_CPU	ALP_CPU_x86

// Must be defined by the build system. 
// Since it's really important, we cannot simply use a default value for it.
#if !defined(ALP_CPU)
#	error ALP_CPU MUST be defined by the build system
#endif

// Can be defined by the build system. 
// Otherwise, default is to do Device builds.
#if !defined(ALP_TARGET)
#	define ALP_TARGET ALP_TARGET_DEVICE
#endif

// Can be defined by the build system. 
// Otherwise, default is to do Device builds.
#if !defined(ALP_TRACE)
#	if ALP_BUILD == ALP_BUILD_DEBUG
#		define ALP_TRACE ALP_TRACE_ON
#	else
#		define ALP_TRACE ALP_TRACE_OFF
#	endif
#endif

// ---------------------------------------------------------------------------
#endif // ALP_CONFIG_H_
