/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <hiker/config_defines.h>
 *
 * @brief Defines for build configuration
 *
 ******************************************************************************/

#ifndef ALP_CONFIG_DEFINES_H_
#define ALP_CONFIG_DEFINES_H_

// ---------------------------------------------------------------------------
// The makefile should set ALP_BUILD_TYPE to one of the following constants.
// Otherwise config.h sets it to a default value.
#define ALP_BUILD_RELEASE	1
#define ALP_BUILD_DEBUG		2

// ---------------------------------------------------------------------------
// The makefile should set ALP_CPU_TYPE to one of the following constants.
// Otherwise config.h sets it to a default value.
#define ALP_CPU_x86			1
#define ALP_CPU_ARM			2

// ---------------------------------------------------------------------------
// The makefile should set ALP_TARGET to one of the following constants.
// Otherwise config.h sets it to a default value.

// Device build
#define ALP_TARGET_DEVICE		1
// Simulator build - This can be used to include code that is useful for
// developers, development or for SDK builds
#define ALP_TARGET_SIMULATOR	2
// Can be used to create UML dedicated binaries that needs to interact with 
// UML subsystem
#define ALP_TARGET_UML			3

// ---------------------------------------------------------------------------
// The makefile should set ALP_TRACE to one of the following constants.
// Otherwise config.h sets it to a default value.
#define ALP_TRACE_ON		1
#define ALP_TRACE_OFF		2

// ---------------------------------------------------------------------------

#define ALP_SDK_VERSION		0x100

// ---------------------------------------------------------------------------
#endif // ALP_CONFIG_DEFINES_H_
