/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file sysutils_pdk.h
 * 
 * @brief Header file for PDK system utility APIs.
 *  Contains the PDK API for the application server and its associated
 *  client library.
 *****************************************************************************/

#ifndef __ALP_SYS_UTILS_PDK_H_
#define __ALP_SYS_UTILS_PDK_H_


#ifdef __cplusplus
extern "C" {
#endif

/*! @addtogroup ALP_SYSTEM_MISC Miscellaneous Utilities
 *  @ingroup ALP_SYSTEM
 *  @{
 */
 
 /************************************************
	PDK.  Available to licensees only.
 ************************************************/


/// Spawn a child process to separate execution from boot script, similar to daemon().
int alp_daemon_start(int nochdir, int noclose);

/// Used after alp_daemon_start() to allow the boot sequence to continue.
int alp_daemon_release(int status);


//! @}

#ifdef __cplusplus
}	// extern "C"
#endif

#endif // __ALP_SYS_UTILS_PDK_H_


