/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <hiker/prv/IpcClient.h>
 *   
 * @brief Private Header file for the ALP IPC Client APIs.
 *
 ******************************************************************************/


#ifndef ALP_IPC_CLIENT_H
#define ALP_IPC_CLIENT_H

// Includes ------------------------------------------------------------------
#include <hiker/ipc.h>

#include <hiker/prv/IpcMessage.h>


// Typedefs ------------------------------------------------------------------
namespace alp {

namespace ipc {

class Client
{
	public:
		Client(const char* channelName, 
			  AlpConnectionUsageHint hint = ALP_IPC_CONNECTION_USAGE_HINT_NONE,
			  uint32_t timeout = 2000);
		~Client();

		alp_status_t	Status()	{ return fStatus; }

		alp_status_t	Send(Message& msg);
		Message			Receive(int32_t what, uint32_t timeout = 2000);

	private:
		AlpConnection*	fConnection;
		alp_status_t	fStatus;
};

}	// namespace ipc

}	// namespace alp


#endif	// ALP_IPC_CLIENT_H
