/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#ifndef _ALP_APPSERVERLOCK_H
#define _ALP_APPSERVERLOCK_H 1

/***********************************************
 * File Description
 **********************************************/

/*! @file appserver_lock.h
      Code to for an exclusive file lock that does not block
      if the lock is already held.
 
      Copyright (c) 2006 PalmSource, Inc.  All right reserverd.
*/     

#include <unistd.h>
#include <fcntl.h>
#include <glib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <hiker/config.h>

#ifdef __cplusplus
extern "C" {
#endif

/*! @brief
   
    gboolean alp_prv_aquirelock( char *filename );
      
    alp_prv_aquirelock locks the file pointed to by filename.  It is 
    OK if the file does not exist.  It will create it and then lock
    it.  The same process can lock the file mulitple times. However it 
    does not keep track of the number of times.  It will return TRUE 
    if it aquired the lock, otherwise it returns FALSE.
    On error it returns FALSE.  This is the standard UNIX file lock 
    so the OS will release the lock when the process dies.

*/
gboolean alp_prv_acquirelock( char *filename );

#ifdef __cplusplus
}
#endif
#endif /* appserver_lock.h*/
