/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/**
 * @file attnmgr_alert.h
 *
 * @brief ALP attention manager alert definitions
 *
 *****************************************************************************/

#ifndef __ALP_ATTN_ALERT_H__
#define __ALP_ATTN_ALERT_H__

/**
 * @addtogroup ALP_ATTN_MGR_PRIVATE
 * @ingroup ALP_ATTN_MGR
 */

/*
 * alert attribute flags
 */
/* where to display alert */
#define ALP_ATTN_ATTR_DISPLAY_ALERT       0x00000001 /* brings an alert up */
#define ALP_ATTN_ATTR_DISPLAY_LIST        0x00000002 /* shows on list */
#define ALP_ATTN_ATTR_DISPLAY_SECONDARY   0x00000004 /* shows on secondary display */

/* type of display (up to 16 types 0-15) */
#define ALP_ATTN_ATTR_TYPE_MASK           0x00000F00 /* mask to extract type */
#define ALP_ATTN_ATTR_TYPE_ATTN           0x00000000 /* attention alert */
#define ALP_ATTN_ATTR_TYPE_PROGRESS       0x00000100 /* progress alert */
#define ALP_ATTN_ATTR_TYPE_ASYNC          0x00000200 /* async alert */
#define ALP_ATTN_ATTR_TYPE_TEST           0x00000F00 /* test attn */

/* misc. control */
#define ALP_ATTN_ATTR_DELETE_ON_BOOT      0x00001000 /* delete on boot */
#define ALP_ATTN_ATTR_DELETE_ON_EXPIRE    0x00002000 /* delete on ttl exceeded*/
#define ALP_ATTN_ATTR_DELETE_ON_SLEEP     0x00004000 /* delete on sys sleep */
/* or maybe DELETE_ON_WAKEUP ??? */

#define ALP_ATTN_ATTR_IS_NOT_MODAL        0x00010000 /* whether or not dialog is modal */
#define ALP_ATTN_ATTR_HAS_CLOSE           0x00020000 /* whether or not dialog has close btn */ 
#define ALP_ATTN_ATTR_NAVIGATE_AWAY       0x00040000 /* looking for a better term */
#define ALP_ATTN_ATTR_DIRECT              0x00080000 /* send alert data to ui direct - no db */
/* not sure how this work since not always possible to start ui - it's async ya know */

/* alert effects */
#define ALP_ATTN_ATTR_SOUND               0x00100000
#define ALP_ATTN_ATTR_VIBRATE             0x00200000
#define ALP_ATTN_ATTR_LEDS                0x00400000
#define ALP_ATTN_ATTR_CUSTOM_1            0x00800000
#define ALP_ATTN_ATTR_CUSTOM_2            0x01000000
#define ALP_ATTN_ATTR_CUSTOM_3            0x02000000

/* class attribute flags */
#define ALP_ATTN_CLASS_DISPLAY_RECENT     0x00000001 /* cause most recent alert to come up */

#endif /* __ALP_ATTN_ALERT_H__ */
