/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/**
 * @file attnmgr_traces.h
 *
 * @brief ALP attention manager API & definitions
 *
 ******************************************************************************/

#ifndef __ALP_ATTN_TRACE_H__
#define __ALP_ATTN_TRACE_H__

#include <hiker/types.h>
#include <hiker/traces.h>
#include <hiker/sysclass.h>

/**
 * @addtogroup ALP_ATTN_MGR_PRIVATE Private
 * @ingroup ALP_ATTN_MGR
 */
/**
 * @defgroup ALP_ATTN_MGR_TRACE Trace Definitions and Macros
 * @ingroup ALP_ATTN_MGR_PRIVATE
 */
/* @{ */

/* trace facilities */
#define ALP_ATTN_TRACE_GEN      ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x000000)
#define ALP_ATTN_TRACE_TEST     ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x010000)
#define ALP_ATTN_TRACE_API      ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x020000)
#define ALP_ATTN_TRACE_DML      ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x030000)
#define ALP_ATTN_TRACE_IPC      ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x040000)
#define ALP_ATTN_TRACE_IPC_SRV  ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x050000)
#define ALP_ATTN_TRACE_ALERT    ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x060000)
#define ALP_ATTN_TRACE_LAUNCH   ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x070000)
#define ALP_ATTN_TRACE_APPS     ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x080000)
#define ALP_ATTN_TRACE_STATUS   ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x090000)
#define ALP_ATTN_TRACE_DAEMON   ALP_TRACE_DEFINE(ALP_CLASS_ATTN, 0x0A0000)


/* Attention Manager specific trace macros */
#define ALP_ATLX(GROUP, str, ...) ALP_TM(TL(ALP_ATTN_TRACE_##GROUP,"%s(): " str, __PRETTY_FUNCTION__, ## __VA_ARGS__))
#define ALP_ATX(GROUP, str, ...)  ALP_TM(T(ALP_ATTN_TRACE_##GROUP, "%s(): " str, __PRETTY_FUNCTION__, ## __VA_ARGS__))
#define ALP_ABX(GROUP, str, ...)  ALP_TM(B(ALP_ATTN_TRACE_##GROUP, str, ## __VA_ARGS__))

#define ALP_ATL(str, ...) ALP_TM(TL(ALP_ATTN_TRACE_GEN, "%s(): " str, __PRETTY_FUNCTION__, ## __VA_ARGS__))
#define ALP_AT(str, ...)  ALP_TM(T(ALP_ATTN_TRACE_GEN, "%s(): " str, __PRETTY_FUNCTION__, ## __VA_ARGS__))
#define ALP_AB(str, ...)  ALP_TM(B(ALP_ATTN_TRACE_GEN, str, ## __VA_ARGS__))

/* @} */

#endif /* __ALP_ATTN_IPC_H__ */
