/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file notify_mgr_prv.h
 *   
 * @brief Private header file for the ALP Notify Manager APIs.
 *   
 ******************************************************************************/



#ifndef NOTIFY_MGR_PRV_H
#define NOTIFY_MGR_PRV_H

#include <hiker/notifymgr.h>

#define ALP_NOTIFY_MGR_SERVER_CHANNEL "alp_notify_server"

// cmd parameter
#define ALP_NOTIFY_CMD_REGISTER		1
#define ALP_NOTIFY_CMD_UNREGISTER	2
#define ALP_NOTIFY_CMD_BROADCAST	3
#define ALP_NOTIFY_CMD_NOTIFY		4
#define ALP_NOTIFY_CMD_NOTIFY_DONE	5
#define ALP_NOTIFY_CMD_CALLBACK		6

// client -> server
typedef struct _AlpNotifyCmdRegister AlpNotifyCmdRegister;
struct _AlpNotifyCmdRegister {
	int cmd;
	int size;

	char notifyType[ALP_NOTIFY_MAX_NOTIFY_SIZE+1];
	void * callback;
    void * userData;
	int priority;
	int flags;
	int pid;
	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	int zero;
};

// client -> server
typedef struct _AlpNotifyCmdUnregister AlpNotifyCmdUnregister;
struct _AlpNotifyCmdUnregister {
	int cmd;
	int size;

	char notifyType[ALP_NOTIFY_MAX_NOTIFY_SIZE+1];
	int flags;
	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	int zero;
};

// client -> server
typedef struct _AlpNotifyCmdBroadcast AlpNotifyCmdBroadcast;
struct _AlpNotifyCmdBroadcast {
	int cmd;
	int size;

	char details[ALP_NOTIFY_MAX_DETAILS_SIZE];
	char notifyType[ALP_NOTIFY_MAX_NOTIFY_SIZE+1];
	int length;
	int flags;
	int queue;
	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	int zero;
};

// server -> client
typedef struct _AlpNotifyCmdNotification AlpNotifyCmdNotification;
struct _AlpNotifyCmdNotification {
	int cmd;
	int size;

	char details[ALP_NOTIFY_MAX_DETAILS_SIZE];
	char notifyType[ALP_NOTIFY_MAX_NOTIFY_SIZE+1];
	void * callback;
    void * userData;
	int length;
	int flags;
	int handled;
	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	char appID2[ALP_NOTIFY_MAX_APPID_SIZE+1];
};

// client -> server
typedef struct _AlpNotifyCmdNotificationDone AlpNotifyCmdNotificationDone;
struct _AlpNotifyCmdNotificationDone {
	int cmd;
	int size;

	int handled;
	int status;
	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	int zero;
};

// client -> server
typedef struct _AlpNotifyCmdCallback AlpNotifyCmdCallback;
struct _AlpNotifyCmdCallback {
	int cmd;
	int size;

	char appID[ALP_NOTIFY_MAX_APPID_SIZE+1];
	int zero;
};

#endif
