/******************************************************************************
  
   Copyright (c) 2006 PalmSource, Inc (an ACCESS company). All rights reserved.

   The contents of this file are subject to the Mozilla Public License Version
   1.1 (the "License"); you may not use this file except in compliance with
   the License. You may obtain a copy of the License at
   http://www.mozilla.org/MPL/

   Software distributed under the License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   for the specific language governing rights and limitations under the
   License.

   The Original Code is the entire contents of this file.

   The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

   Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
   Rights Reserved.

   Contributor(s): none.
 *****************************************************************************/
/*!
 * @file <hiker/sysclass.h>
 *
 * @brief This file defines system component identifiers for traces and status
 *
 ******************************************************************************/

#ifndef HIKER_SYSCLASS_H_
#define HIKER_SYSCLASS_H_

// ---------------------------------------------------------------------------
#include <hiker/types.h>


// ---------------------------------------------------------------------------
#define ALP_STATUS_CLASS(x)		(((alp_status_t)(x))&0xFF000000)
#define ALP_STATUS_VALUE(x)		(((alp_status_t)(x))&0xFFFF0000)
#define ALP_STATUS_INFO(x)		(((alp_status_t)(x))&0x0000FFFF)


// ---------------------------------------------------------------------------
#define ALP_CLASS_UNDEFINED          0x01000000
#define ALP_CLASS_APPSERVER          0x02000000
#define ALP_CLASS_EXCHANGE           0x04000000
#define ALP_CLASS_NOTIFY             0x05000000
#define ALP_CLASS_BUNDLE             0x06000000
#define ALP_CLASS_SAL                0x08000000
#define ALP_CLASS_IPC                0x0E000000
#define ALP_CLASS_GLOBAL_SETTINGS    0x10000000
#define ALP_CLASS_VOLUMESVCS         0x12000000
#define ALP_CLASS_BUNDLEMGR          0x16000000
#define ALP_CLASS_SPF                0x1B000000
#define ALP_CLASS_NLPD               0x1C000000
#define ALP_CLASS_LSM                0x1F000000
#define ALP_CLASS_ATTN               0x21000000
#define ALP_CLASS_ALARM              0x23000000
#define ALP_CLASS_POWER              0x27000000


// ---------------------------------------------------------------------------
#endif // HIKER_TYPES_H_
