/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/**
 * @file syspaths.h
 *
 * @brief Path definitions specific to ALP.
 *
 */

#ifndef __HIKER_SYSPATHS_H__
#define __HIKER_SYSPATHS_H__

/**
 * @defgroup ALP_SYSPATH System Path Definitions
 * @ingroup ALP_SYSTEM
 * @{
 */
#define ALP_SYSPATH_NAME        "alp"
#define ALP_EXT_SYSPATH_PREFIX  "/ALP"

/**
 * @name  RO Paths
 * @brief Paths to common ALP read only areas.
 * @{
 */
#define ALP_SYSPATH_RO_PREFIX    "/opt/" ALP_SYSPATH_NAME "/"
#define ALP_SYSPATH_BIN          ALP_SYSPATH_RO_PREFIX "bin/"
#define ALP_SYSPATH_ETC          ALP_SYSPATH_RO_PREFIX "etc/"
#define ALP_SYSPATH_LIB          ALP_SYSPATH_RO_PREFIX "lib/"
#define ALP_SYSPATH_SCRIPTS      ALP_SYSPATH_RO_PREFIX "scripts/"
#define ALP_SYSPATH_RO_BUNDLES   ALP_SYSPATH_RO_PREFIX "bundles/"
#define ALP_SYSPATH_RO_DATA      ALP_SYSPATH_RO_PREFIX "data/"
/* @} */

/**
 * @name  R/W Paths
 * @brief Paths to common ALP read / write areas.
 * @{
 */
#define ALP_SYSPATH_HOME         "/home/"

#define ALP_SYSPATH_LOCK         "/var/lock/"
#define ALP_SYSPATH_TRACES       "/var/traces/"
#define ALP_SYSPATH_VAROPT       "/var/opt/"

#define ALP_SYSPATH_RW_PREFIX    ALP_SYSPATH_VAROPT ALP_SYSPATH_NAME "/"
#define ALP_SYSPATH_RW_DATA      ALP_SYSPATH_RW_PREFIX "data/"
#define ALP_SYSPATH_LIB_DATA     ALP_SYSPATH_RW_DATA   "lib/"
#define ALP_SYSPATH_SYSTEM_CACHE ALP_SYSPATH_RW_DATA   "syscache/"
#define ALP_SYSPATH_BUNDLE_DATA  ALP_SYSPATH_RW_DATA   "bundles/"
#define ALP_SYSPATH_PREFS        ALP_SYSPATH_RW_PREFIX "prefs"
                                    /* note this is a file, not a directory!!! */
#define ALP_SYSPATH_BUNDLES      ALP_SYSPATH_RW_PREFIX "bundles/"

#define ALP_EXT_SYSPATH_HIDDEN_VOL    ALP_EXT_SYSPATH_PREFIX "/HIDDEN.VOL"
#define ALP_EXT_SYSPATH_CARD_XML      ALP_EXT_SYSPATH_PREFIX "/CARD.XML"
#define ALP_EXT_SYSPATH_DATA          ALP_EXT_SYSPATH_PREFIX "/DATA/"
#define ALP_EXT_SYSPATH_BUNDLES               ALP_EXT_SYSPATH_PREFIX "/BUNDLES/"
/* @} */

/* @} */

#endif /* __HIKER_SYSPATHS_H__ */
