/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
 /*!
 * @file <hiker/types.h>
 *
 * @brief Provides standard types for ALP platform
 *
 ******************************************************************************/

#ifndef ALP_TYPES_H_
#define ALP_TYPES_H_

/*  --------------------------------------------------------------------------- */
#include <stdint.h>
#if defined(__GNUC__)
#	include <stdbool.h>
#elif defined(WIN32)
#include <stdbool.h>
#else
#	error Make sure bool, true and false are defined even when using the C compiler
/*  	Then add a test on a macro uniquely defining your compiler above. */
#endif
#include <hiker/config.h>

/*  --------------------------------------------------------------------------- */
typedef uint32_t        alp_status_t;

typedef void           *AlpDmlH;
typedef void           *AlpDmlStatementH;
typedef void           *AlpDmlItemH;

typedef uint32_t        AlpLuid;

#define ALP_STATUS_OK		0

/*  #### TO BE REMOVED */
#define ALP_OK				0
#define ALP_INVALID_PARAM	((alp_status_t)0x01000000 | 2)

/*  --------------------------------------------------------------------------- */
#endif	/*  ALP_TYPES_H_ */
