/********************************************************************

Copyright  2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/**
 * @file alarm_cmd.c
 *
 * @brief ALP Alarm Manager command line interface
 *
 *****************************************************************************/

#include <glib.h>

#include <hiker/types.h>
#include <hiker/alarmmgr.h>

static gchar  *set_alarm_id      = NULL;
static gchar  *cancel_alarm_id   = NULL;
static gchar  *get_alarm_id      = NULL;

static gchar  *alarm_ref  = NULL;

static gboolean list_alarms = FALSE;
static gboolean wipe_alarms = FALSE;

static GOptionEntry entries[] = 
{
  { "set", 's', 0, G_OPTION_ARG_STRING, &set_alarm_id, "Set an alarm", "Application ID/BAR URL" },
  { "cancel", 'c', 0, G_OPTION_ARG_STRING, &cancel_alarm_id, "Cancel an alarm", "Application ID/BAR URL" },
  { "get", 'g', 0, G_OPTION_ARG_STRING, &get_alarm_id, "Get an alert", "Application ID/BAR URL" },
  { "list", 'L', 0, G_OPTION_ARG_NONE, &list_alarms, "List alarms", NULL },
  { "wipe", 0, 0, G_OPTION_ARG_NONE, &wipe_alarms, "Wipe alarms", NULL },
  { "ref", 'r', 0, G_OPTION_ARG_STRING, &alarm_ref, "Alarm reference", "a number" },
  { NULL, 0, 0, 0, NULL, NULL, NULL }
};

int 
main (int argc, char *argv[])
{
    alp_status_t     status;
    GError          *error = NULL;
    GOptionContext  *context;
    GOptionGroup    *group;
    gchar          **p;
    guint            count = 0;
    guint            i;
    
    context = g_option_context_new ("- alarm manager command line interface");
    group = g_option_group_new ("foo", "bar", "bletch", NULL, NULL);
    g_option_group_add_entries (group, entries);
    g_option_context_set_main_group (context, group);
    if (!g_option_context_parse (context, &argc, &argv, &error)) {
        g_print ("Option parsing error occurred.\n");
    }

    g_print ("argc = %d, argv[0] = %s\n", argc, argv[0]);
    for (i = 0; i < (guint) argc; i++) {
        g_print ("    argv[%d] = %s\n", i, argv[i]);
    }
 

    return 0;
}

