/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/

#define PERM_ADD_STORE_POLICY "com.access.bundlemgr.add_store"
#define PERM_DELETE_STORE_POLICY "com.access.bundlemgr.delete_store"
#define PERM_INCREF_POLICY "com.access.bundlemgr.incref"
#define PERM_DECREF_POLICY "com.access.bundlemgr.decref"
#define PERM_OPEN_POLICY "com.access.bundlemgr.open"
#define PERM_HOLD_NOTIFICATIONS_POLICY "com.access.bundlemgr.hold_notifications"
#define PERM_WIPE_POLICY "com.access.bundlemgr.wipe"
#define PERM_RW_PATHNAME_POLICY "com.access.bundlemgr.rw_pathname"
#define PERM_RW_DELETE_POLICY "com.access.bundlemgr.rw_delete"

// These defines refer to columns in the 'store' table, which can be
// set when the store is created. When an operation on a particular
// store is tried, a policy column is read, and if is not NULL, then
// the column contents are used as a string containing a policy name,
// which is given to the SPF to verify whether the caller should be
// permitted a particular operation on that store. Note the indirection:
// the SPF policy names are given when the store is created, and are
// not inherant in the Bundle Manager. If a column is NULL, there is
// no policy name, and permission is _granted_ by default.
#define PERM_REGISTER_POLICY_COLUMN "register_policy"
#define PERM_UNREGISTER_POLICY_COLUMN "unregister_policy"
#define PERM_DELETE_POLICY_COLUMN "delete_policy"
#define PERM_INSTALL_POLICY_COLUMN "install_policy"
#define PERM_SCAN_POLICY_COLUMN "scan_policy"

extern gboolean has_permission(AlpConnection * con, const char * policy_name);
extern gboolean has_store_permission_by_store(AlpConnection * con, const char * policy_name_column, const char * store_name);
extern gboolean has_store_permission_by_bundle(AlpConnection * con, const char * policy_name_column, AlpBundle index);



