/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*! @file prvexgmgr.h 
 *
 * @brief private headers for exgmgr.c
 *
*/
#ifndef PRVEXGMGR_H_
#define PRVEXGMGR_H_

#include <sys/types.h>
#include <hiker/types.h>
#include <hiker/bundlemgr.h>

#define ALP_EXGMGR_PARAMETER_TYPE_STRING 'S'
#define ALP_EXGMGR_PARAMETER_TYPE_INT 'I'
#define ALP_EXGMGR_PARAMETER_TYPE_BLOB 'B'

#define ALP_EXGMGR_VERB_TAG "ALP_EXG_VERB"
#define ALP_EXGMGR_URL_TAG "ALP_EXG_URL"
#define ALP_EXGMGR_MIME_TAG "ALP_EXG_MIME"
#define ALP_EXGMGR_TRANSPORT_TAG "ALP_EXG_XPORT"
#define ALP_EXGMGR_GENERIC_TAG "ALP_EXG_GENERIC"

typedef struct _AlpExgMgrTransportInfoType AlpExgMgrTransportInfoType;
struct _AlpExgMgrTransportInfoType {
	AlpBundleRef itsBundleRef;
	gchar *itsNameId;		// internal name, non localizable, as used in the transport params
	gchar *itsLibPath;		// full path to the lib plugin.
	void *itsLibRef;
	alp_exg_transport_execute_request_func itsTransportExecuteRequestFunc;
};

#define ALP_EXGMGR_ITSINFO_GROW_SIZE 512
typedef struct _AlpExgRequestType AlpExgRequestType;
struct _AlpExgRequestType {
	int itsExgVersion;	// Exchange manager version
	char *itsInfo;		// string representation of all the parameters, verb, description, url...
	size_t itsInfoLen;		// used size of the Info buffer
	size_t itsInfoSize;	// maximum size of the Info buffer
	int itsDataFd;		// > 0 if a data source was specified
	int itsDaemonFd;	// > 0 when the handler is currently executing and connected to the daemon
	char *itsRcvInfo;	// received parameters (used for received request only)
	size_t itsRcvInfoLen;	// size of RcvInfo buffer (used for received request only)
	int itsRcvDataFd;	// received data Fd. (used for received request only)
};

#endif /*PRVEXGMGR_H_*/
