/********************************************************************

Copyright  2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file policy_strings.c
 *
 * @brief security framework policy strings for Global Settings APIs
 *
 *****************************************************************************/

#include "hiker/global_settings.h"
#include "policy_strings.h"

static const char *policy_strings[] = 
{
     0, //GLOBAL_SETTINGS_APP_ID ".begin_transaction",
    
     0, //GLOBAL_SETTINGS_APP_ID ".complete_transaction",
     0, //GLOBAL_SETTINGS_APP_ID ".cancel_transaction",  
     GLOBAL_SETTINGS_APP_ID ".set", //".set_default_mode",
     GLOBAL_SETTINGS_APP_ID ".get", //".get_default_mode",
     GLOBAL_SETTINGS_APP_ID ".set", //".set_mode",
     GLOBAL_SETTINGS_APP_ID ".get", //".get_mode",
     GLOBAL_SETTINGS_APP_ID ".set", //".set_uid",
     GLOBAL_SETTINGS_APP_ID ".get", //".get_uid",
     GLOBAL_SETTINGS_APP_ID ".set", //".set_gid",
     GLOBAL_SETTINGS_APP_ID ".get", //".get_gid",
    
     GLOBAL_SETTINGS_APP_ID ".set",
     GLOBAL_SETTINGS_APP_ID ".get",
    
     GLOBAL_SETTINGS_APP_ID ".set", //".delete",
     GLOBAL_SETTINGS_APP_ID ".set", //".delete_tree",
    
     GLOBAL_SETTINGS_APP_ID ".get", //".findkeys_start",
     
     0, //GLOBAL_SETTINGS_APP_ID ".server_quit",
     
     0, //GLOBAL_SETTINGS_APP_ID ".open",
     0, //GLOBAL_SETTINGS_APP_ID ".close",
     
     0, //GLOBAL_SETTINGS_APP_ID ".ping", 
     GLOBAL_SETTINGS_APP_ID ".get", //".get_type",
     GLOBAL_SETTINGS_APP_ID ".get", //".get_value_size",
     
     0, //GLOBAL_SETTINGS_APP_ID ".set_notification_on_off",
     
     GLOBAL_SETTINGS_APP_ID ".set", //".import_from_file",
    
     GLOBAL_SETTINGS_APP_ID ".set", //".delete_tree_keeping_defaults",
     
     GLOBAL_SETTINGS_APP_ID ".get", //".list_keys", 
     
     0 

} ;

const char *policy_strings_get(ALP_GLOBAL_SETTINGS_RPC_PROCS proc_id)
{
    return policy_strings[proc_id - PROC_begin_transaction];
}
