/********************************************************************

Copyright  2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file proc_id.h
 *
 * @brief remote procedure IDs.
 *
 *****************************************************************************/


#ifndef __PROC_ID_H__
#define __PROC_ID_H__


#ifdef __cplusplus
extern "C" {
#endif


typedef enum ALP_GLOBAL_SETTINGS_RPC_PROCS 
{
     PROC_begin_transaction = 100,
     PROC_complete_transaction,
     PROC_cancel_transaction,  
     PROC_set_default_mode,
     PROC_get_default_mode,
     PROC_set_mode,
     PROC_get_mode,
     PROC_set_uid,
     PROC_get_uid,
     PROC_set_gid,
     PROC_get_gid,
    
     PROC_set,
     PROC_get,
    
     PROC_delete,
     PROC_delete_tree,
    
     PROC_findkeys_start,
     
     PROC_server_quit,
     
     PROC_open,
     PROC_close,
     
     PROC_ping, 
     PROC_get_type,
     PROC_get_value_size,
     
     PROC_set_notification_on_off,
     
     PROC_import_from_file,
    
     PROC_delete_tree_keeping_defaults,
     
     PROC_list_keys 
     

} ALP_GLOBAL_SETTINGS_RPC_PROCS;

#ifdef __cplusplus
}       // extern "C"
#endif

#endif
