/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
// Includes ------------------------------------------------------------------
#include <hiker/prv/IpcClient.h>


//----------------------------------------------------------------------------

namespace alp {

namespace ipc {

Client::Client(const char* channelName, AlpConnectionUsageHint hint,
			uint32_t timeout)
	:	fConnection(NULL)
{
//SB_LOG("%s, %ld", channelName, timeout);
	fStatus = alp_ipc_channel_connect_synch(channelName, hint, timeout, &fConnection);
	if (fStatus)
		fConnection = NULL;
//SB_LOG("err == 0x%08lX", err);
}


Client::~Client()
{
	if (fConnection)
		alp_ipc_channel_disconnect(fConnection);
}


alp_status_t Client::Send(Message& msg)
{
	return msg.Send(fConnection);
}


Message Client::Receive(int32_t what, uint32_t timeout)
{
	AlpMessage* msg = NULL;
	if (alp_ipc_connection_receive(fConnection, what, timeout, &msg))
		return Message();
	return msg;
}

}	// namespace ipc

}	// namespace alp
