/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*! 
 * @file "sal_prv.h"
 ******************************************************************************/

#ifndef ALP_SAL_PRV_H_
#define ALP_SAL_PRV_H_       1

#include <hiker/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sqlite3.h>

/*Typedefs*******************************************************************/
typedef struct {
	sqlite3_stmt *stmt;
	//!< SQLite Statement handle
	int32_t bindPosition;
	//!< Used to automatically increment an index used to read out columns in rows found after alp_sal_statement_next_result
	AlpSALHandle sal;
	//!< Keep track of datamodel handel statement is attached to
} _AlpSALStatement;


/*alpSALPrv.c****************************************************************/
extern alp_status_t 	alp_prv_sal_translate_sqlite_err(int32_t sqliteErr);
extern bool				alp_prv_sal_file_exists(const char *fileName);

#endif /* ALP_SAL_PRV_H */

