/******************************************************************************
 * Copyright (c) 2006 PalmSource, Inc (an ACCESS company). All rights reserved.
 *****************************************************************************/
/*!
 * @file <platform/libraries/traces/tests/testtraces.c>
 *
 * @brief Sample file for testing traces on ALP
 *
 ******************************************************************************/


#include <unistd.h>

//#include <stdio.h>


#include "testtraces.h"

/*------------------------------------------------------*/
/* Display at compile time the status of ALP_TRACE				*/
/* Begin: Remove the warning displayed
#if ALP_TRACE == ALP_TRACE_ON
#warning "ALP_TRACE is ALP_TRACE_ON"
#else
#warning  "ALP_TRACE is ALP_TRACE_OFF"
#endif
   End : Remove the warning displayed  */

#define ALP_TTL(str, ...) ALP_TM(TL(testTraceClass, "%s(),%d: " str, __PRETTY_FUNCTION__, __LINE__, __VA_ARGS__))


/*-----------------------------------*/
void SendFrame(void);

/*-----------------------------------*/
/*-----------------------------------*/
int main(int argc, char **argv)
{
	char c;


	printf("Traces class: %X\n",testTraceClass);
	printf("\t0 - stderr\n");
	printf("\t1 - File\n");
	printf("\t2 - TCP:oguiter1.palmsource.com\n");
	printf("\t3 - Syslog\n");
	printf("\t4 - XML\n");
	printf("\t5 - TraceMgr over TCP Test (use PALMTRACE_TARGET)\n");
	printf("\t6 - Fail test\n");
	printf("\t\n");
	
	do
	{
		c = getchar();
	} while ((c < '1') && (c > '5'));

	if (c == '6')
	{
		ALP_FAIL_NON_FATAL_IF(c == '6', "Test %d works %s\n", 6, "correctly");
		ALP_FAIL_FATAL_IF(c == '6', "Test %d works %s\n", 6, "correctly");
		printf("This should not be displayed.\n");
	}
	else

	if (c == '0')
	{
	    printf("STDerr Mode:\n");
		alp_trace_init(0, "stderr", 0);
	}
	else
	if (c=='1')
	{
		printf ("File Mode:\n");
		alp_trace_init(0, "file", "/home/oguiter/filetest.txt");
	}
	else
	if (c == '2')
	{
	    	printf("TCP Mode:\n");
		alp_trace_init(0, "tcp", "yourreporter.palmsource.com");
	}
	else
	if (c=='3')
	{
		printf ("SYSLOG Mode:\n");
		alp_trace_init(0, "syslog", 0);
	}
	else
	if (c=='4')
	{
		printf ("XML Mode:\n");
		alp_trace_init(0, "xml", "/home/oguiter/testxmlogu.xml");
	}
	else
	if (c=='5')
	{
	    printf("TraceMgr TCP Mode:\n");
//	    alp_trace_init(0, "tcp", "oguiterm60.palmsource.com");
	}
	
	
	if (c !='5')			//Raw test
	{		
		ALP_TM(TL(testTraceClass, "First Frame:"));
		SendFrame();
		ALP_TM(TL(testTraceClass, "Second Frame:"));
		SendFrame();
	
	}
	else
	{			//TraceMgrTest
		unsigned char	theBuffer[121];
		printf("Entering Test: \n");
		
		 alp_trace_setoutput("tcp","oguiter1.palmsource.com");
		 while(1)
		 {
			 ALP_TM(TL(testTraceClass, "TTrace: Entering Test Traces class: %X\n",testTraceClass));
			 SendFrame();
			 sleep(1);
			 ALP_TM(TL(testTraceClass, "TTrace: Ending Test"));
		 }		
	}

	ALP_TM(TL(testTraceClass, "Close Now !"));
	alp_trace_close();

	return 0;
}


/*-----------------------------------*/
/*-----------------------------------*/
void SendFrame(void)
{
	unsigned char theBuffer[121];

	printf("Entering Test: \n");
	ALP_TM(TL(testTraceClass, "This is a test."));
	ALP_TM(TL(testTraceClass, "%#2hx.", 4));
	// Not working		TraceOutput(TL(0x0100, "[\\n\\r\\t] = [\n\r\t]"));
	// Not working 		TraceOutput(TL(0x0100, "Specials: [�]");)
	theBuffer[0] = 0xE9;
	theBuffer[1] = 0xE8;
	ALP_TM(TL(testTraceClass, "%lu.", theBuffer[0]));
	ALP_TM(TL(testTraceClass, "Specials in a buffer:"));
	ALP_TM(B(testTraceClass, theBuffer, 2));
	{
		int i;
		for (i = 0; i < (int)sizeof(theBuffer) - 1; i++)
			theBuffer[i] = i;
		theBuffer[sizeof(theBuffer) - 1] = 0;
		ALP_TM(TL(testTraceClass, "Buffer in ASCII: %s", theBuffer + 1));
		ALP_TM(T(testTraceClass, "Buffer in HEXA"));
		ALP_TM(B(testTraceClass, theBuffer, sizeof(theBuffer)));
	}
	ALP_TTL("Test ALP_TTL macro: %s, %d", "Test", 2);
}

