/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <platform/libraries/traces/tests/testtraces.c>
 *
 * @brief Sample file for testing traces on ALP
 *
 ******************************************************************************/

#ifndef _TESTTRACES_H_
#define _TESTTRACES_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

/*------------------------------------------------------*/
/* file needed to get the ALP_TRACE define						*/
#include <hiker/config_defines.h>

/*------------------------------------------------------*/
/* Uncomment to test trace on or off							*/
// #define ALP_TRACE ALP_TRACE_OFF		//For testing purpose

/*------------------------------------------------------*/
/* Required header file to use the traces						*/
#include <hiker/traces.h>

/*  Define Application Trace Class. */
#define testTraceClass			ALP_TRACE_DEFINE(ALP_CLASS_UNDEFINED, getpid())

#if BUILD_TYPE == BUILD_TYPE_DEBUG
#	define testtracesDbgBeginProc(func)	ALP_TM(TL(testTraceClass, "%s: Processing...", #func));
#else
#	define testtracesDbgBeginProc(func)
#endif

#ifdef __cplusplus
}
#endif // __cplusplus

#endif  // _TESTTRACES_H_
