/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 *  @file "Traces_conf_util.h"
 *
 *  @brief Configuration helper (include file) for traces
 *
 *********************************************************************************/

#ifndef __CONF_UTIL_H__
#define __CONF_UTIL_H__


#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
	CONF_RDONLY = ((unsigned char) 0x01), /* Read only */
	CONF_RDWR = ((unsigned char) 0x02),   /* Read and write */
	CONF_CREATE = ((unsigned char) 0x04)  /* Create file */
} ALPConfType;

/* Read/get */
char *prv_conf_read_string(const char *section, const char	*key, const char *def);
int prv_conf_read_int	( const char *section, const char *key, int def);
int prv_conf_read_list( const char	*section, const char *key, int *argcp, char ***argvp);
int prv_conf_get_sections (int	*argcp, char	***argvp);
int prv_conf_get_keys ( const char *section, int	*argcp, char	***argvp);

/* Write */
int prv_conf_write_string	(const char	*section, const char *key, const char *value);
int prv_conf_write_int	(const char	*section, const char *key, int value);
int prv_conf_write_list	(const char	*section, const char*key, int argc, char **argv);

/* Removing */
int prv_conf_delete_section	(const char	*section);
int prv_conf_delete_key	( const char	*section, const char	*key);

/* File mgt functions */
int prv_conf_getfile (const char *path, const ALPConfType options);
void prv_conf_close (void);
int prv_conf_flush (void);


#ifdef __cplusplus
}
#endif

#endif  /* __CONF_UTIL_H__*/

