/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <traces_fac.c>
 *
 * @brief Main dispatcher for traces library.
 *
 ******************************************************************************/

#include <stdlib.h>
#include <string.h>

#include "traces_fac.h"
#include "traces_file.h"
#include "traces_stderr.h"
#include "traces_tcp.h"
#include "traces_syslog.h"
#include "traces_xml.h"
#include "traces_null.h"


/*	------------------------------------------------------------------- */
char				sAppName[MAX_PATH];

/*	------------------------------------------------------------------- */
static void GetAppName(char* aBuffer, unsigned long anInstance)
{
	FILE *f;
	char line[MAX_PATH], *res, *rbuf, *cp, *tmp = NULL;
	char buf[MAX_PATH];

	strcpy(line, "Empty");
	
	f = fopen("/proc/self/cmdline", "r");
	if (f)
	{
		rbuf = fgets(line, sizeof (buf), f);
		/* rbuf is like "./myfilename"   */
	
		// fprintf (stderr, "+++++ cmdline[%s] \n", rbuf);
		//Not sure what to do exactly with the line but... ;) */
	
		fclose(f);
	}
	
	strcpy(sAppName, line);
	
}

/*	------------------------------------------------------------------- */
void InstanciateTracer(unsigned long anInstance, const char* aTracerType)
{
	/* Initialize the source application name buffer once */
	GetAppName(sAppName, anInstance);

 	gTracer = 0;
	
	if (strcasecmp(aTracerType, "file") == 0)
		gTracer = TrFile_Create();
	else
	if (strcasecmp(aTracerType, "stderr") == 0)
		gTracer = TrStdErr_Create();
	else
	if (strcasecmp(aTracerType, "tcp") == 0)
		gTracer = TrTCP_Create();
	else
	if (strcasecmp(aTracerType, "syslog") == 0)
		gTracer = TrSyslog_Create();
	else
	if (strcasecmp(aTracerType, "xml") == 0)
		gTracer = TrXML_Create();
	else
	if (strcasecmp(aTracerType, "null") == 0)
		gTracer = TrNull_Create();
	
}

