/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <traces_main.h>
 *
 * @brief Internal header file for traces shared library. 
 *
 ******************************************************************************/

#ifndef _TRACES_MAIN_H
#define _TRACES_MAIN_H

/*	------------------------------------------------------------------- */
#include <stdint.h>
#include <stdarg.h>


/*	------------------------------------------------------------------- */
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */

#include <malloc.h>
#include <pthread.h>


#define InitializeCriticalSection(a) pthread_mutex_init( a, 0 )
#define CreateMutex(nul, own, name) pthread_mutex_init( a, 0 )
#define EnterCriticalSection pthread_mutex_lock
#define LeaveCriticalSection pthread_mutex_unlock
#define DeleteCriticalSection pthread_mutex_destroy
#define ReleaseMutex(m) pthread_mutex_destroy( &m )
#define CRITICAL_SECTION pthread_mutex_t

#define MAX_PATH 250



/*	------------------------------------------------------------------- */
#ifdef __cplusplus
}
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */
#endif /* PalmTrace_h */
