/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <traces_stderr.h>
 *
 * @brief Header file for generating  traces to stderr output.
 *
 ******************************************************************************/

#ifndef _TRACES_STDERR_H
#define _TRACES_STDERR_H

/*	------------------------------------------------------------------- */
#include <stdio.h>
#include "traces_main.h"

/*	------------------------------------------------------------------- */
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */
/*	StdErr tracer uses the same structure as FileTracer */
/*	------------------------------------------------------------------- */
TTracer*	TrStdErr_Create(void);

/*	------------------------------------------------------------------- */
int	TrStdErr_OpenProc(TTracer* aTracer, const char*);
void	TrStdErr_CloseProc(TTracer* aTracer);
void	TrStdErr_DestroyProc(TTracer* aTracer);
long	TrStdErr_DisconnectedProc(TTracer* aTracer);

/*	------------------------------------------------------------------- */
#ifdef __cplusplus
}
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */
#endif /* _TRACES_STDERR_H */
