/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file <traces_xml.h>
 *
 * @brief Header file for generating XML traces. 
 *
 ******************************************************************************/

#ifndef _TRACES_XML_H
#define _TRACES_XML_H

/*	------------------------------------------------------------------- */
#include <stdio.h>
#include "traces_main.h"
#include "traces_helper.h"

/*	------------------------------------------------------------------- */
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */

/*	------------------------------------------------------------------- */
typedef struct _TXMLTracer
{
	int		itsfOpened;
	int		itsfFirstTrace;
	int		itsOutputKind;
	int		(*itsOpenProc)(TTracer* aTracer, const char*);
	void		(*itsCloseProc)(TTracer* aTracer);
	void		(*itsSendProc)(TTracer* aTracer, TTraceSendParams* aParams);
	long		(*itsDisconnectedProc)(struct _TTracer* aTracer);
	void		(*itsDestroyProc)(struct _TTracer* aTracer);

	FILE*		itsFile;
} TXMLTracer;

/*	------------------------------------------------------------------- */
TTracer*	TrXML_Create(void);

/*	------------------------------------------------------------------- */
int	TrXML_OpenProc(TTracer* aTracer, const char*);
void	TrXML_CloseProc(TTracer* aTracer);
void	TrXML_SendProc(TTracer* aTracer, TTraceSendParams* aParams);
long	TrXML_DisconnectedProc(TTracer* aTracer);
void	TrXML_DestroyProc(TTracer* aTracer);

/*	------------------------------------------------------------------- */
#ifdef __cplusplus
}
#endif /* __cplusplus */

/*	------------------------------------------------------------------- */
#endif /* TrTXML_h */
