/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <errno.h>
#include <hiker/volumesvcs.h>
#include <hiker/ipc.h>
#include <hiker/traces.h>
#include <hiker/prv/volumesvcs_prv.h>

/*
 * a serer helper utility that is invoked by a udev rule and sends the
 * environemnt specified in prv/volumesvcs.h to the serer via an alp ipc
 */
int main(int argc, char *argv[])
{
	AlpConnection *con=NULL;
	AlpMessage *msg=NULL;
	alp_status_t as=ALP_STATUS_OK;
	guint i;
	int cmd;
	char *value;

	value = getenv("ACTION");
	if (value == NULL) {
		fprintf(stderr, "no ACTION env var, no msg sent\n");
		as = 1; // just need != ALP_STATUS_OK
	} else {
		as = alp_ipc_channel_connect_synch(ALP_VOLUMESVCS_UDEV_CHANNEL,ALP_IPC_CONNECTION_USAGE_HINT_NONE,0,&con);
		if (as != ALP_STATUS_OK || (msg=alp_ipc_message_create()) == NULL) {
			fprintf(stderr, "could not create message\n");
			if (as == ALP_STATUS_OK)
				as = 1; // just need != ALP_STATUS_OK
		} else {
			if (strcmp(value, "add") == 0) {
				cmd = ALP_VOLUMESVCS_UDEV_ADD;
				PACKSTART( as, msg, cmd, error);
				for (i=0; i<ALP_VOLUMESVCS_UDEV_CODES; i++) {
					value = getenv(sudevmap[i].envvar);
					if ( value && (strlen(value) == 0) )
						value = NULL;
					PACKU32( as, msg, i, error);
					PACKSTR( as, msg, value, error);
				}
			} else {
				cmd = ALP_VOLUMESVCS_UDEV_REMOVE;
				PACKSTART( as, msg, cmd, error);
				value = getenv(sudevmap[ALP_VOLUMESVCS_DEVPATH_CODE].envvar);
				PACKSTR( as, msg, value, error);
			}
			PACKEND( as, msg, error );
		as = alp_ipc_connection_send( con, msg);
		}
	}


error:
	if (as != ALP_STATUS_OK) {
		fprintf(stderr, "alp error %x errno: %d\n",as,errno);
		exit(1);
	}
	exit(0);
}
