//
//    Copyright © 2002-2006, ACCESS Systems Americas, Inc. All rights reserved.
/********************************************************************

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#include <hiker/prv/nlpd_bits.h>
//
// This function renames a running process.
// It does not change the /proc/procID/exe link.
// It does seem to change it for the "ps" command
// and the "top" command.
//
// This returns 0 if it succeed.  1 if it had
// a problem.  There is no error recovery possible
// so this is just informational.  An example of 
// a 1 would be if the new name of the process is
// long than the old name.  In that case it only 
// copies what will fit.
//
//
int alp_prv_rename_process( char *NewName, char *argv[] )
{
	int returnvalue = 0;
	size_t len = strlen(argv[0]);
	//
	// Did we need to trim the string?
	//
	if (len > strlen(NewName))
		returnvalue = 1;

	if (strlen(NewName) > strlen(argv[0]))
		NewName+= strlen(NewName) - strlen(argv[0]);
	//
	// This is just some magic I found
	// via google.  Man pages do not
	// cover it.
	//
	if (prctl( 15, NewName, 0,0,0) != 0)
		returnvalue = 1;

	//
	// Copy what will fit into argv[0]
	//
	if(argv[0] != NewName) strncpy( argv[0], NewName, len);

	return(returnvalue);
}

