/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#include <hiker/prv/appserver_lock.h>

static struct flock lock;
gboolean alp_prv_acquirelock( char *filename )
{
	if (filename == NULL)
		return(FALSE);

	int FD;
	FD = open( filename, O_RDWR | O_CREAT | O_NONBLOCK, S_IRWXU );

	if (FD == -1)
	{
		perror("unable to open file");
		return(FALSE);
	}
	int RV;

	lock.l_type = F_WRLCK;
	lock.l_whence = SEEK_SET;
	lock.l_start = 0;
	lock.l_len = 1;
	lock.l_pid = getpid();

	if ((RV = fcntl(FD, F_SETLK, &lock)) == -1)
		return(FALSE);

	return(TRUE);
}
