/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*! @file bundlemgrd.c
	This file sets up a process as a context to run the server
	side of the MAX Package Manager. The implementation is in
	the Package Manager library.
 */


// Uncomment the next line to disable traces AT COMPILE TIME 
#define ALP_TRACE ALP_TRACE_OFF		//Enable/disable


#include <errno.h>
#include <time.h>
#include <signal.h>
#include <string.h>
#include <limits.h> // for PATH_MAX
#include <unistd.h>
#include <sys/types.h>
#include <hiker/pdk/appmgr_pdk.h>
#include <hiker/ipc.h>
#include <hiker/traces.h>
#include <hiker/bundlemgr.h>
#include <hiker/prv/bundlemgr_prv.h>
#include <hiker/fail.h>
#include <hiker/pdk/sysutils_pdk.h> // for alp_daemon_*

int main(int argc, char *argv[])
{
	GMainLoop *mainLoop;

	alp_daemon_start(FALSE, TRUE);
	
	g_thread_init(NULL);
	
	mainLoop = g_main_loop_new(NULL, FALSE);
	
	ALP_TM(TL(ALP_APP_SERVER_TRACE, "Package Manager Server starting up..."));

	alp_status_t result = alp_prv_bundle_init(TRUE, NULL, NULL, NULL, NULL, NULL, TRUE);
	
	alp_daemon_release((result != ALP_STATUS_OK) ? 1 : 0);

	// run main loop - now we will start handling requests.
	g_main_loop_run(mainLoop);
	
	ALP_TM(TL(ALP_APP_SERVER_TRACE, "Package Manager Server shutting down..."));

	alp_prv_bundle_fini();

	return 0;
}
