/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/*!
 * @file gs_svr_main.h
 *
 * @brief 
 *       the implementation of the Global Settings server daemon.
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>
#include "hiker/pdk/sysutils_pdk.h"

#include "global_settings_server.h"

int main(int argc, char *argv[])
{

    int i, result;
    static struct option long_options[] =
        {
            { "stop", 0, 0, 's'
            },
            { "foreground", 0, 0, 'f' },
            { 0, 0, 0, 0}
        } ;

    if (argc > 3)
    {
        fprintf(stderr, "Usage: %s [-f] db_file_name\n       %s --stop\n", argv[0], argv[0]);
        exit(1);
    }

    if ((argc == 2) && !strcmp(argv[1], "--stop"))
    {
        alp_global_settings_server_stop();
        exit(0);
    }
    if (ALP_STATUS_OK == alp_global_settings_server_running())
    {
        fprintf(stderr, "%s: an existing server is already running\n", argv[0]);
        exit(1);
    }

    if ((argc == 2) && (strcmp(argv[1], "-f") == 0))
    {
        argv[1] = argv[2];
        argv[2] = 0;
        argc--;
    }
    else
    {
	alp_daemon_start(0, 0);
    }
    return AlpGlobalSettingsServerMain(argc, argv);
}
