/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#include <hiker/notifymgr.h>
#include <hiker/prv/notifymgr_prv.h>
#include <hiker/pdk/notifymgr_pdk.h>
#include "notify_mgr_server_prv.h"

#include <hiker/bundlemgr.h>
#include <hiker/prv/bundlemgr_prv.h>
#include <hiker/fail.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int sPackageMgrInit = 0;

// initialize the package manager
void alp_notify_package_init(void)
{
	// initialize the package manager
	if (!sPackageMgrInit && (alp_bundle_init() == ALP_STATUS_OK))
		sPackageMgrInit = 1;
}

// handles package manager package register notification
// remove all registrations for the given appID
int alp_notify_package_uninstall(const char * appID)
{
#ifdef ALP_NOTIFY_DEBUG
	printf("alp_notify_package_uninstall\n");
#endif
	return alp_notify_register_remove_all(appID,0);
}
