/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityKernel.h
**
** Security Object Interface
**
** This file defines the interface for SecurityObject functions that
** interact with the kernel directly.
**
*/
 

/* Macro Definitions */
#ifndef _H_ALP_PRV_SECURITYKERNEL_
#define _H_ALP_PRV_SECURITYKERNEL_

/* File Includes */
#include "SecurityObject.h"

/* Function Prototypes */
AlpPrvSpfSoErr alp_prv_spf_so_kernel_initialize( SecurityObject *object );
AlpPrvSpfSoErr alp_prv_spf_get_user_group_from_pid( SecurityObject *object, unsigned int pid, unsigned int *out_user, unsigned int *out_group );
AlpPrvSpfSoErr alp_prv_spf_so_kernel_load_meta();
AlpPrvSpfSoErr alp_prv_spf_so_kernel_dump_meta();
AlpPrvSpfSoErr alp_prv_spf_so_kernel_lsm_enable();

#endif
