/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityManifest.h
**
**
** Security Object Interface
**
** This file defines the interface for the SecurityObject.
**
*/

/* Macro Definitions */
#ifndef _H_ALP_PRV_SECURITYMANIFEST_
#define _H_ALP_PRV_SECURITYMANIFEST_

/* File Includes */
#include "SecurityObject.h"
#include <glib.h>

/* Typedefs, Structs, Unions, Enums, etc. */


typedef struct {
    char *_name;
    char *_xmlData;
    AlpPrvSpfSoCertificateReference _cert;
} AlpPrvSpfManifest;


AlpPrvSpfSoErr alp_prv_spf_sm_parse (SecurityObject *object, 
                                    AlpPrvSpfManifest *manifest, 
				    unsigned int len);
#endif

