/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityPKCS5Support..h
**
**
** Security PKCS5 Interface
**
**
*/


/* Macro Definitions */
#ifndef _H_ALP_PRV_SECURITYPKCS5SUPPORT_
#define _H_ALP_PRV_SECURITYPKCS5SUPPORT_

#define SHA1_HASH_SIZE                20
#define MAX_PKCS5_PHRASE_LEN          256
#define MAX_PKCS5_SALT_LEN            256
#define DEFAULT_ITERATION_COUNT       1000

/* File Includes */
#include <glib.h>
#include <stdio.h>
#include <dbus/dbus-glib.h>
#include "SecurityUtilities.h"


void alp_prv_spf_pkcs5_init_default (AlpPrvSpfSuPKCS5 **context, char *id);

void alp_prv_spf_pkcs5_init (AlpPrvSpfSuPKCS5 **context, 
                             char *salt, 
                             unsigned int iteration, 
                             char *id);

gboolean alp_prv_spf_pkcs5_set_phrase (SecurityObject *obj, 
                                       unsigned int which, 
                                       char *phrase, 
                                       GError **error);

gboolean alp_prv_spf_pkcs5_check_phrase (SecurityObject *obj,
                                                  unsigned int which,
                                                  char *trial_phrase,
                                                  unsigned int *correct,
                                                  GError **error); 

gboolean alp_prv_spf_pkcs5_set_parameters (SecurityObject *obj,
                                                    unsigned int which,
                                                    unsigned int iteration,
                                                    unsigned int active,
                                                    char *salt,
                                                    GError **error);

gboolean alp_prv_spf_pkcs5_get_parameters (SecurityObject *obj,
                                                    unsigned int which,
                                                    unsigned int *iteration,
                                                    unsigned int *active,
                                                    char **salt,
                                                    GError **error);

void alp_prv_spf_pkcs5_fput (AlpPrvSpfSuPKCS5 *context, FILE *fp);

#endif
