/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityQuery.h
**
**
** Query Interface Functions for the SPF Security Service
**
** $Id:$
*/

/* Macro Definitions */
#ifndef _H_ALP_PRV_SECURITYQUERY_
#define _H_ALP_PRV_SECURITYQUERY_

gboolean alp_prv_spf_query_get_assertion_string (SecurityObject *obj,
                                                 uint policy_id,
                                                 char *assertion,
                                                 unsigned int subject_pid,
                                                 unsigned int client_pid,
                                                 gchar **out_assertion_value,
                                                 GError **error);

gboolean alp_prv_spf_query_get_assertion_type (SecurityObject *obj,
                                              unsigned int policy_id,
                                              char *assertion,
                                              unsigned int subject_pid,
                                              unsigned int client_pid,
                                              unsigned int *out_assertion_type,
                                              GError **error); 


gboolean alp_prv_spf_query_complete (SecurityObject *obj, 
		                     unsigned int id, 
				     gchar **out_assertion_value, 
				     unsigned int *out_exit_okay, 
				     GError **error);

#endif /* _H_ALP_PRV_SECURITYQUERY_ */
