/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityService.h
**
**
** Security Service Private Interface
**
**
*/
#ifndef _H_ALP_PRV_SECURITYSERVICE_
#define _H_ALP_PRV_SECURITYSERVICE_

#include "SecurityObject.h"

#ifdef DEBUG
#define d(msg) if( app.debug != 0 ) { fputs( msg, app.debug_fp ); fflush( app.debug_fp ); }
#else
#define d(msg)
#endif


/* Macro Definitions */
#define ALP_PRV_SPF_DEFAULT_CONFIG_FILE_PATH_RO "/etc/default.policy"
#define ALP_PRV_SPF_DEFAULT_CONFIG_FILE_PATH_RW "/var/opt/alp/data/lib/security/policy"
#define ALP_PRV_SPF_SECURITY_XML_FILE "security.xml"
#define ALP_PRV_SPF_DEFAULT_LOG_FILE_PATH "/var/log/security"
#define ALP_PRV_SPF_DEFAULT_USER "security"
#define ALP_PRV_SPF_DEFAULT_GROUP "security"
#define ALP_PRV_SPF_DEFAULT_UID 105
#define ALP_PRV_SPF_DEFAULT_GID 105
#define ALP_PRV_SPF_UI_TWO_SIMPLE

#define SECURITY_TYPE_OBJECT (security_object_get_type())
#define SECURITY_OBJECT(object) (G_TYPE_CHECK_INSTANCE_CAST ( ( object ) , SECURITY_TYPE_OBJECT , SecurityObject ) )
#define SECURITY_OBJECT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), SECURITY_TYPE_OBJECT, SecurityObjectClass))
#define SECURITY_IS_OBJECT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), SECURITY_TYPE_OBJECT))
#define SECURITY_IS_OBJECT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), SECURITY_TYPE_OBJECT))
#define SECURITY_OBJECT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), SECURITY_TYPE_OBJECT, SecurityObjectClass))

AlpPrvSpfSoErr alp_prv_get_policy_and_package_from_pids (
                                        SecurityObject *obj,
                                        unsigned int client_pid,
                                        unsigned int subject_pid,
                                        AlpPrvSpfSoSecurityPolicy **out_policy,
                                        AlpPrvSpfSoPackage **out_package);
#endif
