/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
/* SecurityUtilities.h
**
**
** Utility Functions for the SPF Security Service
**
** This file contains the interface to a number of utility functions for use
** by the  SPF. Many of these functions  are here to mask  the complexity of
** using the OpenSSL C API.
**
** $Id:$
*/

/* Macro Definitions */
#ifndef _H_ALP_PRV_SECURITYUTILITY_
#define _H_ALP_PRV_SECURITYUTILITY_

/* File Includes */
#include <stdio.h>

typedef struct {
  char *salt;
  unsigned int salt_length;
  unsigned int iteration;
  unsigned int active;
  char *id;
  unsigned char phrase[20];
} AlpPrvSpfSuPKCS5;


/* Function Prototypes */

void alp_prv_spf_rfc1113_encode (char *input, 
		                 unsigned int input_length, 
				 char *output, 
				 unsigned int output_max_length, 
				 unsigned int *output_bytes_written );

void alp_prv_spf_rfc1113_decode (char *input, 
		                 unsigned int input_length, 
				 char *output, 
				 unsigned int output_max_length, 
				 unsigned int *output_bytes_written);

void alp_prv_spf_sha1 (char *input, 
		       unsigned int input_length, 
		       unsigned char *output);

#endif /* _H_ALP_PRV_SECURITYUTILITY_ */
