/********************************************************************

Copyright 2006, ACCESS Systems Americas, Inc. All rights reserved.

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is the entire contents of this file.

The Initial Developer of the Original Code is ACCESS Systems Americas, Inc.

Portions created by ACCESS Systems Americas, Inc. are Copyright  2006. All
Rights Reserved.

Contributor(s): none.

********************************************************************/
#include <sys/time.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// This is a simple utility for printing out the current time
// in seconds since some time in 1970.  This is really too big
// so it just prints the last three digits.
// 
// We use this for timing.
int main( int argc, char *argv[] )
{
	struct timeval *tv = 
		(struct timeval *)malloc(sizeof(struct timeval));
	struct timezone *tz = 
		(struct timezone *)malloc(sizeof(struct timezone));
	gettimeofday(tv, tz);
	long double fraction = (double)tv->tv_usec / 1000000 ;
	fraction += (tv->tv_sec % 1000);
	if ((argc > 1) && ((strcmp("--help", argv[1]) == 0) ||
		          (strcmp("-?", argv[1]) == 0))) {
		printf("Time prints out a truncated timestamp in seconds\n");
		printf("Usage : Time | Time \"comment\" | Time \"source\" \"comment\"\n");
		return(0);
	}

	if (argc > 2)
	{
		printf( 
	           " -- *%s. %s at time %4.3Lf\n", argv[1], argv[2], fraction );
	}
	else if (argc > 1)
		printf( " -- %s at time %4.3Lf\n", argv[1], fraction );
	else
		printf( " -- Time %4.3Lf\n", fraction );
	return(0);
}
